# -*- coding: utf-8 -*-
import json
import sys
import hmac
import copy
import urllib
from hashlib import sha1

import requests

reload(sys)
sys.setdefaultencoding('utf-8')


class Alibaba(object):
    '''
    对速卖通的接口api做一个整合，主要设计到产品上架相关接口
    以及之后需要处理的订单下载接口
    '''

    app_key = 'app_key'
    secret_key = 'secret_key'
    refresh_token = "refresh_token"
    refresh_token_timeout = "refresh_token_timeout"
    access_token = 'access_token'
    code = 'code'

    redirect_uri = 'http://elm.starmerx.com:8001/order/get_code/'
    site = '1688'
    state = 'starmerx'

    service = {
        'code': 'http://gw.open.1688.com',
        'auth': 'https://gw.open.1688.com',
        'common': 'https://gw.open.1688.com',
    }

    class_command = {
        'code': '/auth/',
        'auth': '/openapi/',
        'common': '/openapi/',
    }

    command = {
        'code': 'authorize.htm',
        'auth': 'http/1/system.oauth2/',
        'common': 'param2/1/',
    }

    function_command = {
        'get_token': 'getToken',
        'refresh_access_token': 'getToken',
        'refresh_refresh_token': 'postponeToken',
        'get_product':'com.alibaba.product/alibaba.agent.product.get'

    }

    def __init__(self, app_key='6145563',secret_key='WuMhUcP8ZtW9',access_token='',refresh_token='3725b2b1-c024-4a36-8675-e86e7bdf734e',code='f4651849-33af-4c51-a745-69bd679d9026'):
        if app_key and secret_key:

            self.app_key = app_key
            self.secret_key = secret_key
            if refresh_token:
                self.refresh_token = refresh_token
                if access_token:
                    self.access_token = access_token
                else:
                    params = {
                        'grant_type': "refresh_token",
                        'need_refresh_token': 'true',
                    }
                    self.refresh_access_token(**params)
            else:
                if not code:
                    url = self.get_authorize_url()
                    print url
                    print '请注意授权'
                else:
                    print 'create code'
                    code_dict = {
                        'grant_type': "authorization_code",
                        'need_refresh_token': 'true',
                        'redirect_uri': self.redirect_uri,
                        'code': code,
                    }
                    self.get_token(**code_dict)

    def __str__(self):
        return 'appKey:' + self.app_key + ',secret_key:' + self.secret_key + ',refresh_token:' + self.refresh_token + ',access_token:' + self.access_token

    def __calc_signature(self, command, params_map):
        """Calculate MWS signature to interface with Amazon
        """

        # 因为授权的时候，只需要对参数进行签名计算，不需要对url进行签名计算
        str_base = command if command.find('auth') == -1 else ''

        params_map1 = sorted(params_map)
        for each in params_map1:
            str_base = str_base + str(each) + str(params_map[each])

        str_base = str_base.replace('domesticLogisticsCompany上门揽收domesticLogisticsCompanyId-1',
                                    'domesticLogisticsCompanyId-1domesticLogisticsCompany上门揽收')
        return hmac.new(str(self.secret_key), str(str_base), sha1).digest().encode('hex').upper()

    def __make_call_proxy(self, url, data=None, header=None):
        """
        通过代理服务器实际发送请求
        :param url: 需要调用的url
        :param data:
        :param header:
        :return:
        """
        _data = {'data': data, 'url': url, 'headers': header}
        print _data
        import urllib2
        try:
            return eval(urllib2.urlopen(self.proxy_host, urllib.urlencode(_data)).read())
        except Exception as e:
            print 'Unkown error:', str(e)
            if str(e).find('timed out') != '-1':
                print 'Unkown error: request again'
                try:
                    return eval(urllib2.urlopen(self.proxy_host, urllib.urlencode(_data)).read())
                except Exception as e:
                    return {'exception': 'timed out', 'message': 'timed out', 'error_code': '0'}
            else:
                return {'exception': 'timed out', 'message': 'timed out', 'error_code': 0}

    def __make_call(self, url, data=None, header=None):
        """
        :param url:需要调用的url
        :return:返回通过post请求，得到对于的url的返回值
        """

        r = requests.post(url, data=data, headers=header)
        result_json = json.loads(r.text)
        # print r.text
        result_json = json.loads(r.text)
        return result_json

    def __make_call_deal(self, service_type, function_type, params={}):
        """
        主要对各调用的一个封装，将请求之类的参数之类的通过公共参数给配置好，方便以后的修改
        :param args:传入的list
        :param kwargs: 传入的dict
        :return:返回请求的结果
        """

        service, class_command, commond, function_command = self.service[service_type], self.class_command[
            service_type], self.command[service_type], self.function_command[function_type]
        headers = {"Content-type": "application/x-www-form-urlencoded", "Accept": "text/plain"}

        total_params = copy.deepcopy(params)
        url_params = {}
        # 如果要检查签名bug，则需要去掉时间戳，不然时间戳影响签名算法
        # url_params['_aop_timestamp'] = str(int(time.time() * 1000))

        total_params.update(url_params)

        url_params['_aop_signature'] = self.__calc_signature(commond + function_command + '/' + str(self.app_key),
                                                             total_params)

        request_url = service + class_command + commond + function_command + '/' + str(
            self.app_key) + '?' + urllib.urlencode(url_params)

        # print '-----------------------------'
        # print params
        # print '-----------------------------'
        # print request_url
        # print '-----------------------------'

        # r = requests.post(request_url, data=params, headers=headers)
        #
        # print r
        # result_data = json.loads(r.text)
        #
        # return result_data
        print 'request_url--------------------------', request_url

        return self.__make_call(request_url, params, headers)

    def get_authorize_url(self):
        """
        :return:返回alibaba授权的url
        授权成功之后得到一个url： self.redirect_uri + state=self.state&code=ede9c269-10d3-44ca-88d6-53030311de04
        """

        service_type = 'code'
        params_map = {
            'client_id': self.app_key,
            'redirect_uri': self.redirect_uri,
            'site': self.site,
            'state': self.state,
        }

        # print self.command[service_type]


        params_map['_aop_signature'] = self.__calc_signature(self.command[service_type], params_map)

        params_map_str = '&'.join([key + '=' + params_map[key] for key in params_map])

        url = self.service[service_type] + self.class_command[service_type] + self.command[
            service_type] + '?' + params_map_str

        return url

    def get_token(self, **params):
        """
        :param params:
            {
                'grant_type':"authorization_code",
                'need_refresh_token':'true',
                'redirect_uri': self.redirect_uri,
                'code':code,
            }
        :return:
        """
        service_type = 'auth'
        function_type = 'get_token'

        params.update({
            'client_id': self.app_key,
            'client_secret': self.secret_key,
            'grant_type': 'authorization_code',
            'need_refresh_token': 'true',
            'redirect_uri': self.redirect_uri,
        })

        result_json = self.__make_call_deal(service_type, function_type, params)

        print result_json

        self.refresh_token_timeout, self.refresh_token, self.access_token = result_json['refresh_token_timeout'], \
                                                                            result_json['refresh_token'], result_json[
                                                                                'access_token']
        self.redirect_uri = params.get('redirect_uri', None) or self.redirect_uri

        return True

    def refresh_access_token(self, **params):
        """
        :param params:
            {
                'grant_type':"refresh_token",
                'need_refresh_token':'true',
            }
        :return:
        """

        service_type = 'auth'
        function_type = 'refresh_access_token'
        params.update({
            'client_id': self.app_key,
            'client_secret': self.secret_key,
            'refresh_token': self.refresh_token,
        })

        result_json = self.__make_call_deal(service_type, function_type, params)
        print result_json

        self.access_token = result_json['access_token']

        return True

    def refresh_refresh_token(self, **params):
        """
        :param params:
            {
                'grant_type':"refresh_token",
                'need_refresh_token':'true',
            }
        :return:
        """

        service_type = 'auth'
        function_type = 'refresh_refresh_token'
        params.update({
            'client_id': self.app_key,
            'client_secret': self.secret_key,
            'refresh_token': self.refresh_token,
            'access_token': self.access_token
        })
        result_json = self.__make_call_deal(service_type, function_type, params)
        result_json.pop('expires_in')
        return result_json

    def set_refresh_token_postpone_token(self, **params):
        """
        :param params:
        :return:
        """

        service_type = 'auth'
        function_type = 'set_refresh_token_postpone_token'

        params.update({
            'client_id': self.app_key,
            'client_secret': self.secret_key,
            'refresh_token': self.refresh_token,
        })

        result_json = self.__make_call_(service_type, function_type, params)

        self.refresh_token_timeout, self.refresh_token, self.access_token = result_json['refresh_token_timeout'], \
                                                                            result_json['refresh_token'], result_json[
                                                                                'access_token']

        return True

    def get_product(self, **params):

        """
        TODO:由商品ID获取商品详细信息，接口能获取非授权用户的商品信息。该接口需要向阿里巴巴申请权限才能访问。注意：该接口不能查询零售通商品。
        :param params:
        :return:商品详细信息
        """
        service_type = 'common'
        function_type = 'get_product'
        params.update({
            'access_token': self.access_token,
            'webSite': '1688'
        })
        return self.__make_call_deal(service_type,function_type,params)


def get_params(productinfo):
    attrs = productinfo.get('attributes',[])
    attr_dict = {}
    for _attr in attrs:
        if attr_dict.has_key(_attr['attributeID']):
            attr_dict[_attr['attributeID']]['value'] = '{},{}'.format(attr_dict[_attr['attributeID']]['value'],_attr['value'])
        else:
            attr_dict[_attr['attributeID']] = {'name':_attr['attributeName'],'value':_attr['value']}

    return attr_dict


def get_attributes(productinfo):
    """
    :param productinfo:
    :return:
    """
    if 'skuInfos' not in productinfo:
        return [],''
    skuinfos = productinfo.get('skuInfos',[])
    sku_info = []
    params_dict = get_params(productinfo)
    for sku in skuinfos:
        tmp_dict = {}
        tmp_dict['variation_id'] = sku['skuId']
        try:
            tmp_dict['price'] = sku['price']
        except:
            tmp_dict['price'] = productinfo.get('saleInfo',{}).get('priceRanges',[{}])[0].get('price')
        tmp_dict['images'] = []
        tmp_dict['stock'] = sku.get('amountOnSale',0)
        tmp_dict['attr_value'] = {}
        for attr_value in sku.get('attributes',[]):
            print attr_value
            tmp_dict['attr_value'][params_dict.get(attr_value['attributeID'],{}).get('name','')] = attr_value['attributeValue']
            if attr_value.get('skuImageUrl',''):
                tmp_dict['images'].append(attr_value.get('skuImageUrl',''))

        sku_info.append(tmp_dict)

    return sku_info, ','.join(map(str,sku_info[0].get('attr_value').keys()))






if __name__ == '__main__':
    import datetime

    st = datetime.datetime.now()
    a = Alibaba(app_key='6145563',secret_key='WuMhUcP8ZtW9',access_token='',refresh_token='3725b2b1-c024-4a36-8675-e86e7bdf734e',code='f4651849-33af-4c51-a745-69bd679d9026')
    print a.access_token
    product =  a.get_product(**{'productID':'537056843865'})

    print get_attributes(product['productInfo'])
